##
##  sendmail.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         sendmail
Summary:      Mail Transfer Agent
URL:          http://www.sendmail.org/
Vendor:       Eric Allman
Packager:     The OpenPKG Project
Distribution: OpenPKG [EVAL]
Group:        Mail
License:      BSD
Version:      8.12.7
Release:      20030103

#   package options
%option       with_tls      no
%option       with_sasl     no
%option       with_milter   no
%option       with_ldap     no

#   list of sources
Source0:      ftp://ftp.sendmail.org/pub/sendmail/sendmail.%{version}.tar.gz
Source1:      etc.sendmail.tar
Source2:      cf.tar
Source3:      fsl.sendmail
Source4:      rc.sendmail

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20030103, m4, fsl, tar, gcc, make, db >= 4.1.25
PreReq:       OpenPKG, openpkg >= 20030103, m4, fsl, make, perl
%if "%{with_tls}" == "yes"
BuildPreReq:  openssl
%endif
%if "%{with_sasl}" == "yes"
BuildPreReq:  sasl, openssl
%endif
%if "%{with_ldap}" == "yes"
BuildPreReq:  openldap, openssl
%endif
AutoReq:      no
AutoReqProv:  no
Provides:     MTA
Conflicts:    ssmtp, exim, postfix

%description
    Sendmail is the most popular Mail Transfer Agent (MTA). This copy
    contains features specific to the OpenPKG distribution including
    fsl(3) logging rather than syslog(3) and optional STARTTLS,
    SMTPAUTH, Milter and LDAP support.

%prep
    #   unpack standard tarballs
    %setup0 -q -c
    %setup1 -q -T -D -a 1

    #   add own M4 stuff to Sendmail configuration set
    ( cd sendmail-%{version}
      %{l_tar} xf %{SOURCE cf.tar}
    )

%build
    #   build Sendmail
    ( cd sendmail-%{version}

      #   indicate with a plus sign that we use a patched version
      chmod u+w sendmail/version.c
      %{l_shtool} subst \
          -e 's;\(Version\[\][^"]*\)"[^"]*";\1"%{version}+";' \
          sendmail/version.c

      #   add linker flag defs for fsl(3)
      LDFLAGS="`%{l_prefix}/bin/fsl-config --ldflags --all`" \
      LIBS="`%{l_prefix}/bin/fsl-config --libs --all`" \

      #   configure Sendmail
      (   echo "define(\`confMAPDEF', \`-DMAP_REGEX')dnl"
          echo "define(\`confSBINOWN', \`%{l_musr}')dnl"
          echo "define(\`confSBINGRP', \`%{l_mgrp}')dnl"
          echo "define(\`confUBINOWN', \`%{l_musr}')dnl"
          echo "define(\`confUBINGRP', \`%{l_mgrp}')dnl"
          echo "define(\`confMANOWN', \`%{l_musr}')dnl"
          echo "define(\`confMANGRP', \`%{l_mgrp}')dnl"
          echo "define(\`confEBINDIR', \`%{l_prefix}/libexec/sendmail')dnl"
          echo "define(\`confHFDIR', \`%{l_prefix}/etc/sendmail')dnl"
          echo "define(\`confHFFILE', \`sendmail.help')dnl"
          echo "define(\`confINCLUDEDIR', \`%{l_prefix}/include/sendmail')dnl"
          echo "define(\`confINSTALL_RAWMAN', \`1')dnl"
          echo "define(\`confLIBDIR', \`%{l_prefix}/lib/sendmail')dnl"
          echo "define(\`confMANROOT', \`%{l_prefix}/man/cat')dnl"
          echo "define(\`confMANROOTMAN', \`%{l_prefix}/man/man')dnl"
          echo "define(\`confMBINDIR', \`%{l_prefix}/sbin')dnl"
          echo "define(\`confSBINDIR', \`%{l_prefix}/sbin')dnl"
          echo "define(\`confSHAREDLIBDIR', \`%{l_prefix}/lib')dnl"
          echo "define(\`confSTDIR', \`%{l_prefix}/var/sendmail')dnl"
          echo "define(\`confSTFILE', \`sendmail.stat')dnl"
          echo "define(\`confUBINDIR', \`%{l_prefix}/bin')dnl"
          echo "define(\`confLNOPTS', \`-f')dnl"
          echo "define(\`confFORCE_RMAIL', \`yes')dnl"
          echo "APPENDDEF(\`confENVDEF', \`-D_PATH_SENDMAILCF=\\\"%{l_prefix}/etc/sendmail/sendmail.cf\\\"')dnl"
          echo "APPENDDEF(\`confENVDEF', \`-D_PATH_SENDMAILPID=\\\"%{l_prefix}/var/sendmail/sendmail.pid\\\"')dnl"
          echo "APPENDDEF(\`confENVDEF', \`-DNEWDB')dnl"
          echo "APPENDDEF(\`confINCDIRS', \`-I%{l_prefix}/include')dnl"
          echo "APPENDDEF(\`confLIBDIRS', \`-L%{l_prefix}/lib')dnl"
          echo "APPENDDEF(\`confLIBS', \`-lfsl -ldb')dnl"
          echo "define(\`confSTDIO_TYPE', \`portable')dnl"
          echo "APPENDDEF(\`confENVDEF', \`-DDNSMAP')dnl"
%if "%{with_tls}" == "yes"
          echo "APPENDDEF(\`conf_sendmail_ENVDEF', \`-DSTARTTLS')dnl"
          echo "APPENDDEF(\`conf_sendmail_LIBS', \`-lssl -lcrypto')dnl"
%endif
%if "%{with_sasl}" == "yes"
          echo "APPENDDEF(\`confENVDEF', \`-DSASL=1')dnl"
          echo "APPENDDEF(\`confINCDIRS', \`-I%{l_prefix}/include/sasl')dnl"
          echo "APPENDDEF(\`confLIBS', \`-lsasl2 -lcrypto')dnl"
%endif
%if "%{with_milter}" == "yes"
          echo "APPENDDEF(\`conf_sendmail_ENVDEF', \`-DMILTER')dnl"
          echo "APPENDDEF(\`conf_libmilter_ENVDEF', \`-D_FFR_MILTER_ROOT_UNSAFE')dnl"
%endif
%if "%{with_ldap}" == "yes"
          echo "APPENDDEF(\`confMAPDEF', \`-DLDAPMAP')dnl"
          echo "APPENDDEF(\`confENVDEF', \`-DSM_CONF_LDAP_MEMFREE=1')dnl"
          echo "APPENDDEF(\`confLIBS', \`-lldap -llber -lssl -lcrypto')dnl"
%endif
      ) >devtools/Site/site.config.m4

      #   build Sendmail package
      %{l_make} %{l_mflags}
    )

%install
    rm -rf $RPM_BUILD_ROOT

    #   manually create filesystem hierarchy, because Sendmail's
    #   install target doesn't properly create it itself.
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/sendmail \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/sbin \
        $RPM_BUILD_ROOT%{l_prefix}/lib \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/sendmail \
        $RPM_BUILD_ROOT%{l_prefix}/man \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1 \
        $RPM_BUILD_ROOT%{l_prefix}/man/man5 \
        $RPM_BUILD_ROOT%{l_prefix}/man/man8 \
        $RPM_BUILD_ROOT%{l_prefix}/man/cat1 \
        $RPM_BUILD_ROOT%{l_prefix}/man/cat5 \
        $RPM_BUILD_ROOT%{l_prefix}/man/cat8

    #   install Sendmail
    ( cd sendmail-%{version}
      myusr=`(id -un) 2>/dev/null ||\
             (whoami) 2>/dev/null ||\
             (who am i | cut "-d " -f1) 2>/dev/null ||\
             echo $LOGNAME`
      mygrp=`(cat /etc/passwd; ypcat passwd) 2>/dev/null |\
             grep "^${myusr}:" | awk -F: '{ print $4; }' | head -1`
      mygrp=`(cat /etc/group; ypcat group) 2>/dev/null |\
             grep ":${mygrp}:" | awk -F: '{ print $1; }' | head -1`
      %{l_shtool} subst \
          -e "s;^\\(SBINOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(SBINGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(UBINOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(UBINGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(GBINOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(GBINGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(MANOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(MANGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(CFOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(CFGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(MBINOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(MBINGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(MSPQOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(MSPQGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(LIBOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(LIBGRP.*=\\).*;\\1 $mygrp;" \
          -e "s;^\\(INCOWN.*=\\).*;\\1 $myusr;" \
          -e "s;^\\(INCGRP.*=\\).*;\\1 $mygrp;" \
          -e 's;ln -s *;$(LN) $(LNOPTS) $(DESTDIR);' \
          Makefile */Makefile */*/Makefile
      %{l_make} %{l_mflags} install DESTDIR=$RPM_BUILD_ROOT \
          MSPQ=%{l_prefix}$MSPQ MAILDIR=%{l_prefix}
      mv $RPM_BUILD_ROOT%{l_prefix}/bin/rmail \
         $RPM_BUILD_ROOT%{l_prefix}/sbin/rmail

      #   install OSSP fsl support
      %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/fsl
      %{l_shtool} install -c -m 644 \
          -e 's;@l_prefix@;%{l_prefix};g' \
          %{SOURCE fsl.sendmail} \
          $RPM_BUILD_ROOT%{l_prefix}/etc/fsl/

      #   remember the Sendmail M4 stuff for re-configuration
      (%{l_tar} cf $RPM_BUILD_ROOT%{l_prefix}/etc/sendmail/cf.tar cf)
      compress $RPM_BUILD_ROOT%{l_prefix}/etc/sendmail/cf.tar
      %{l_shtool} install -c -m 644 cf/README \
          $RPM_BUILD_ROOT%{l_prefix}/etc/sendmail/cf.README
      %{l_shtool} install -c -m 755 contrib/re-mqueue.pl \
          $RPM_BUILD_ROOT%{l_prefix}/sbin/re-mqueue
      %{l_shtool} install -c -m 755 -e 's;^#!.*;#!%{l_prefix}/bin/perl;' \
          contrib/qtool.pl $RPM_BUILD_ROOT%{l_prefix}/sbin/qtool
      %{l_shtool} install -c -m 755 -e 's;^#!.*;#!%{l_prefix}/bin/perl;' \
          contrib/qtool.8 $RPM_BUILD_ROOT%{l_prefix}/man/man8/qtool.8
    )

    #   install a reasonable default configuration
    ( cd etc.sendmail
      l_hostname=`%{l_shtool} echo -e %h`
      l_domainname=`%{l_shtool} echo -e %d | cut -c2-`
      l_ostype=bsd4.4
      case "%{l_target}" in
          *-freebsd4*)  l_ostype=freebsd4 ;;
          *-freebsd*)   l_ostype=bsd4.4   ;;
          *-solaris2.8) l_ostype=solaris8 ;;
          *-solaris*)   l_ostype=solaris2 ;;
          *-linux*)     l_ostype=linux    ;;
      esac
      %{l_shtool} install -c -m 644 \
          -e 's;@l_prefix@;%{l_prefix};g' \
          -e 's;@l_musr@;%{l_musr};g' \
          -e 's;@l_mgrp@;%{l_mgrp};g' \
          -e "s;@l_hostname@;${l_hostname};g" \
          -e "s;@l_domainname@;${l_domainname};g" \
          -e "s;@l_ostype@;${l_ostype};g" \
          * $RPM_BUILD_ROOT%{l_prefix}/etc/sendmail/
    )

    #   install the run-command script
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_musr@;%{l_musr};g' \
        -e 's;@l_mgrp@;%{l_mgrp};g' \
        %{SOURCE rc.sendmail} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   create important files which have to be present from the beginning
    %{l_shtool} mkdir -f -p -m 700 \
        $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/mqueue \
        $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/mqueue/.hoststat
    %{l_shtool} mkdir -f -p -m 770 \
        $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/clientmqueue \
        $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/clientmqueue/.hoststat
    touch $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/sendmail.in.pid
    touch $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/sendmail.out.pid
    touch $RPM_BUILD_ROOT%{l_prefix}/var/sendmail/sendmail.log

    #   adjust installation tree
    rm -rf $RPM_BUILD_ROOT%{l_prefix}/man/cat*
    chmod -R u+w $RPM_BUILD_ROOT%{l_prefix}/
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/*              2> /dev/null || true
    strip $RPM_BUILD_ROOT%{l_prefix}/sbin/*             2> /dev/null || true
    strip $RPM_BUILD_ROOT%{l_prefix}/libexec/sendmail/* 2> /dev/null || true

    #   determine file list
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%attr(2755,root,%{l_rgrp})        %{l_prefix}/sbin/sendmail' \
        '%attr(4755,root,%{l_mgrp})        %{l_prefix}/bin/hoststat' \
        '%attr(4755,root,%{l_mgrp})        %{l_prefix}/bin/mailq' \
        '%attr(4755,root,%{l_mgrp})        %{l_prefix}/bin/newaliases' \
        '%attr(4755,root,%{l_mgrp})        %{l_prefix}/bin/purgestat' \
        '%attr(4755,root,%{l_mgrp})        %{l_prefix}/bin/vacation' \
        '%attr(4755,root,%{l_mgrp})        %{l_prefix}/libexec/sendmail/smrsh' \
        '%attr(755,root,%{l_mgrp})         %{l_prefix}/etc/sendmail' \
        '%config                           %{l_prefix}/etc/sendmail/*' \
        '%config %attr(644,root,%{l_mgrp}) %{l_prefix}/etc/sendmail/ca.crt' \
        '%config %attr(644,root,%{l_mgrp}) %{l_prefix}/etc/sendmail/sendmail.crt' \
        '%config %attr(600,root,%{l_mgrp}) %{l_prefix}/etc/sendmail/sendmail.key' \
        '%config %{l_prefix}/etc/fsl/fsl.sendmail' \
        '%not %dir %{l_prefix}/etc/fsl' \
        '%attr(700,root,%{l_mgrp})         %{l_prefix}/var/sendmail/mqueue' \
        '%attr(700,%{l_rusr},%{l_rgrp})    %{l_prefix}/var/sendmail/clientmqueue' \
        '%attr(644,root,%{l_mgrp})         %{l_prefix}/var/sendmail/sendmail.log' \
        '%attr(644,root,%{l_mgrp})         %{l_prefix}/var/sendmail/sendmail.*.pid'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

%post
    if [ $1 -eq 1 ]; then
        (cd $RPM_INSTALL_PREFIX/etc/sendmail; %{l_make} all >/dev/null 2>&1 || true)
    elif [ $1 -gt 1 ]; then
        (cd $RPM_INSTALL_PREFIX/etc/sendmail; %{l_make} clean all >/dev/null 2>&1 || true)
        $RPM_INSTALL_PREFIX/etc/rc sendmail reload >/dev/null 2>&1 || true
    fi

%preun
    if [ $1 -eq 0 ]; then
        $RPM_INSTALL_PREFIX/etc/rc sendmail stop >/dev/null 2>&1 || true
        (cd $RPM_INSTALL_PREFIX/etc/sendmail/; %{l_make} clean >/dev/null 2>&1 || true)
    fi

